proc PhotoMisc.methods obj { 
 sd.new.method calculate.offset.to.window for $obj takes {win p type} {
  if {[string equal $win $p]} {
   return 0
  } else {
   set np [winfo parent $win]
   return [expr {[winfo $type $win] + [$self->calculate.offset.to.window $np $p $type]}] 
  }
 }

 sd.new.method limit.integer.range.to for $obj takes {n max} {
  return [expr {($n > $max) ? $max : $n}]
 }

 sd.new.method make.region.fit.image for $obj takes {xPtr yPtr x2Ptr y2Ptr img} {
  upvar $xPtr x ; upvar $yPtr y ; upvar $x2Ptr x2 ; upvar $y2Ptr y2

  set maxX [image width $img]
  set maxY [image height $img]
   
  set x [$self->limit.integer.range.to $x $maxX]
  set y [$self->limit.integer.range.to $y $maxY]
  set x2 [$self->limit.integer.range.to $x2 $maxX]
  set y2 [$self->limit.integer.range.to $y2 $maxY]
 }

 return $obj
}
